var TREE_SIZE = 20;
var NUM_TREES = 1;
var IGNITE_RADIUS = 35;
var BURN_RADIUS = 1;
var BURN_RATE = 100;
var newCan;
var myPen;
var trees = new Array();

function initInput(){
	NUM_TREES = document.getElementById("NUM_TREES").value;
	IGNITE_RADIUS = document.getElementById("IGNITE_RADIUS").value;
	BURN_RATE = document.getElementById("BURN_RATE").value;
	BURN_RADIUS = document.getElementById("BURN_RADIUS").value;
}
	
function makeForest(){
	initInput();
	newCan = document.getElementById("theForest");
	myPen = newCan.getContext("2d");
	var randomX, randomY;
	var hSize = newCan.height - (TREE_SIZE/2);
	var wSize = newCan.width - (TREE_SIZE/2);
	myPen.clearRect(0,0,newCan.width,newCan.height);
	for(var i = 0; i < NUM_TREES; i++){		
		randomX= Math.floor(Math.random() * wSize) + 1;
		randomY= Math.floor(Math.random() * hSize) + 1;
		trees[i] = new Object;
		trees[i].xVal = randomX;
		trees[i].yVal = randomY;
		trees[i].fireOn = false;
		var img=document.getElementById("Tree1");
		myPen.drawImage(img,trees[i].xVal-(TREE_SIZE/2),trees[i].yVal-(TREE_SIZE/2));
	}
	newCan.addEventListener("mousedown", startFire, false);
}

function findDistance(x1, y1, x2, y2){
	var distance = Math.sqrt(Math.pow((x1 - x2),2) + Math.pow((y1 - y2),2));
	return(distance);
}

function startFire(event) {
	var distance = new Array();
	var xFire = event.pageX - newCan.offsetLeft;
	var yFire = event.pageY - newCan.offsetTop;
	myPen.beginPath();
	for(var i = 0; i < NUM_TREES; i++){
		distance[i] = findDistance(trees[i].xVal, trees[i].yVal, xFire, yFire);
		if(distance[i] <= IGNITE_RADIUS && trees[i].fireOn === false){
			trees[i].fireOn = true;
			myPen.clearRect(trees[i].xVal-(TREE_SIZE/2),trees[i].yVal-(TREE_SIZE/2),TREE_SIZE,TREE_SIZE);
			var img=document.getElementById("Tree4");
			myPen.drawImage(img,trees[i].xVal-(TREE_SIZE/2),trees[i].yVal-(TREE_SIZE/2));
		}
	}
	setInterval("burn()", 100);
}

function burn() {
	for(var i = 0; i < NUM_TREES; i++){
		if(trees[i].fireOn === true){
			for(var j = 0; j < NUM_TREES; j++){
				if(trees[j].fireOn === false){
					var distance = findDistance (trees[i].xVal, trees[i].yVal, trees[j].xVal, trees[j].yVal);
					if(distance <= BURN_RADIUS){
						if(Math.random() < (BURN_RATE/100)) {
							trees[j].fireOn = true;
						}
					}
				}
			}
		}
	}
	checkFire();
}

function checkFire(){
	for(var i = 0; i < NUM_TREES; i++){
		if(trees[i].fireOn === true){
			myPen.clearRect(trees[i].xVal-(TREE_SIZE/2),trees[i].yVal-(TREE_SIZE/2),TREE_SIZE,TREE_SIZE);
			var img=document.getElementById("Tree4");
			myPen.drawImage(img,trees[i].xVal-(TREE_SIZE/2),trees[i].yVal-(TREE_SIZE/2));
		}
	}
}